models/Courses.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "courses".
 *
 * @property int $course_id
 * @property string $course_title
 * @property string $course_desc
 * @property string $course_content
 * @property string $course_type
 * @property int $course_is_online
 * @property string $course_price
 * @property int $course_star
 * @property int $course_created_by
 * @property string $course_created_at
 * @property int|null $course_modified_by
 * @property string $course_modified_at
 * @property int $course_status
 * @property int $course_is_deleted
 * @property string|null $course_photo
 *
 * @property CourseSection[] $courseSections
 * @property Enroll[] $enrolls
 */
class Courses extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'courses';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['course_title', 'course_desc', 'course_content', 'course_type', 'course_price', 'course_created_by'], 'required'],
            [['course_content'], 'string'],
            [['course_is_online', 'course_star', 'course_participant_limit', 'course_created_by', 'course_modified_by', 'course_status', 'course_is_deleted', 'course_trainer'], 'integer'],
            [['course_created_at', 'course_modified_at'], 'safe'],
            [['course_title'], 'string', 'max' => 100],
            [['course_desc', 'course_photo'], 'string', 'max' => 255],
            [['course_type'], 'string', 'max' => 50],
            [['course_price'], 'string', 'max' => 20],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'course_id' => 'Course ID',
            'course_title' => 'Course Title',
            'course_desc' => 'Course Desc',
            'course_content' => 'Course Content',
            'course_type' => 'Course Type',
            'course_is_online' => 'Course Is Online',
            'course_price' => 'Course Price',
            'course_star' => 'Course Star',
            'course_participant_limit' => 'Jumlah Participant',
            'course_created_by' => 'Course Created By',
            'course_created_at' => 'Course Created At',
            'course_modified_by' => 'Course Modified By',
            'course_modified_at' => 'Course Modified At',
            'course_status' => 'Course Status',
            'course_is_deleted' => 'Course Is Deleted',
            'course_photo' => 'Course Photo',
            'course_trainer' => 'Course Trainer', 
        ];
    }

    /**
     * Gets query for [[CourseSections]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCourseSections()
    {
        return $this->hasMany(CourseSection::className(), ['course_id' => 'course_id']);
    }

    /**
     * Gets query for [[Enrolls]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getEnrolls()
    {
        return $this->hasMany(Enroll::className(), ['enroll_courseid' => 'course_id']);
    }

    /**
    * Gets query for [[CourseTrainer]]. 
    * 
    * @return \yii\db\ActiveQuery 
    */ 
   public function getCourseTrainer() 
   { 
       return $this->hasOne(Users::className(), ['user_id' => 'course_trainer']); 
   } 
}

controllers/CoursesController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Courses;
use app\models\CourseSection;
use app\models\CoursesSearch;
use app\models\Users;
use Exception;
use PDO;
use Throwable;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\web\HttpException;
use yii\web\Response;

/**
 * CoursesController implements the CRUD actions for Courses model.
 */
class CoursesController extends Controller
{

    public $enableCsrfValidation = false;
    public $layout = 'dashboard';

    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    //'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all Courses models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new CoursesSearch;
        $dataProvider = $searchModel->search(Yii::$app->request->getQueryParams());

        return $this->render('index', [
            'dataProvider' => $dataProvider,
            'searchModel' => $searchModel,
        ]);
    }

    /**
     * Displays a single Courses model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        $model = $this->findModel($id);

        $sections = [];

        foreach ($model->courseSections as $k => $v) {
            if (!isset($sections[$v['section_title']])) {
                $sections[$v['section_title']] = [];
            }

            $sections[$v['section_title']][] = $v;
        }

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->course_id]);
        } else {
            return $this->render('view', [
                'model' => $model,
                'sections' => $sections,
            ]);
        }
    }

    /**
     * Creates a new Courses model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Courses;
        $users = ArrayHelper::map(Users::find()->orderBy(['user_nama' => SORT_ASC])->all(), 'user_id', 'user_nama');

        if ($model->load(Yii::$app->request->post())) {
            $model->course_created_by = Yii::$app->user->identity->user_id;
            if (!$model->save()) {
                die(var_dump($model->errors));
            }
            return $this->redirect(['sections', 'id' => $model->course_id]);
        } else {
            return $this->render('create', [
                'model' => $model,
                'users' => $users,
            ]);
        }
    }

    public function actionCreateFromTemplate()
    {

        $model = new Courses;
        $users = ArrayHelper::map(Users::find()->orderBy(['user_nama' => SORT_ASC])->all(), 'user_id', 'user_nama');
        $courses = ArrayHelper::map(Courses::find()->orderBy(['course_title' => SORT_ASC])->all(), 'course_id', 'course_title');

        if (Yii::$app->request->isPost) {

            $template = Courses::find()->where(Yii::$app->request->post('template'))->asArray()->one();

            if (!$template) {
                throw new Exception("Invalid template");
            }

            $sections = CourseSection::find()->where(['course_id' => $template])->asArray()->all();


            $model->setAttributes($template);
            $model->course_trainer = Yii::$app->request->post('trainer');
            if (!$model->save()) {
                throw new Exception("Failed to save course");
            }

            foreach ($sections as $section) {
                $newSection = new CourseSection;
                $newSection->setAttributes($section);
                $newSection->course_id = $model->course_id;
                if (!$newSection->save()) {
                    throw new Exception("Failed to save template");
                }
            }

            return $this->redirect(['sections', 'id' => $model->course_id]);
        } else {
            return $this->render('create_from_template', [
                'model' => $model,
                'users' => $users,
                'courses' => $courses,
            ]);
        }
    }

    /**
     * Updates an existing Courses model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        $users = ArrayHelper::map(Users::find()->orderBy(['user_nama' => SORT_ASC])->all(), 'user_id', 'user_nama');

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['sections', 'id' => $model->course_id]);
        } else {
            return $this->render('update', [
                'model' => $model,
                'users' => $users,
            ]);
        }
    }

    public function actionSections($id)
    {
        $model = Courses::findOne($id);
        $sections = $model->getCourseSections()->orderBy(['section_order' => SORT_ASC, 'subsection_order' => SORT_ASC])->all();

        if (!$model) {
            throw new \yii\web\NotFoundHttpException("Page not found");
        }

        return $this->render('sections', [
            'model' => $model,
            'sections' => $sections,
        ]);
    }

    public function actionSaveSections()
    {

        Yii::$app->response->format = Response::FORMAT_JSON;

        $transaction = Yii::$app->db->beginTransaction();
        $response = [
            'status' => true,
            'status_code' => 200,
            'message' => 'Success',
            'result' => null
        ];

        try {

            $request = Yii::$app->request;
            $courseId = $request->post('course_id');
            $sections = $request->post('sections');

            $course = Courses::findOne($courseId);

            if (!$course) {
                throw new Exception("Course not found");
            }

            CourseSection::deleteAll('course_id = ' . $courseId);

            $subsectionOrder = 1;
            foreach ($sections as $section) {
                unset($section['id']);
                $courseSection = new CourseSection;
                $courseSection->setAttributes($section);
                $courseSection->subsection_order = $subsectionOrder;
                if (!$courseSection->save()) {
                    throw new Exception("Failed to save course section: " . current($courseSection->errors)[0]);
                }

                $subsectionOrder++;
            }

            $transaction->commit();
        } catch (Throwable $e) {
            $transaction->rollBack();
            $response['status'] = false;
            $response['status_code'] = 500;
            $response['message'] = $e->getMessage();
        } finally {
            return $response;
        }
    }

    /**
     * Deletes an existing Courses model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {

        if (Yii::$app->user->identity->user_tipe != 'ADMIN') {
            throw new HttpException(403, "You are not authorized");
        }

        $transaction = Yii::$app->db->beginTransaction();
        try {

            CourseSection::deleteAll("course_id = $id");
            $this->findModel($id)->delete();

            $transaction->commit();
        } catch (Throwable $e) {
            $transaction->rollBack();
            die($e->getMessage());
        }


        return $this->redirect(['index']);
    }

    /**
     * Finds the Courses model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Courses the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Courses::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

views/courses/_form.php
<?php

use yii\helpers\Html;
use kartik\widgets\ActiveForm;
use kartik\builder\Form;
use kartik\datecontrol\DateControl;
use dosamigos\ckeditor\CKEditor;
use kartik\widgets\StarRating;

/**
 * @var yii\web\View $this
 * @var app\models\Courses $model
 * @var yii\widgets\ActiveForm $form
 */
?>

<div class="card card-primary">
    <div class="card-header">
        <h3 class="card-title">Courses</h3>
    </div>

    <div class="card-body">


        <?php $form = ActiveForm::begin(['type' => ActiveForm::TYPE_HORIZONTAL, 'options' => ['enctype' => 'multipart/form-data']]); ?>

        <div class="row">
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <?= $form->field($model, 'course_title')->textInput(['placeholder' => "Enter Title"]) ?>

                <?= $form->field($model, 'course_desc')->textInput(['placeholder' => "Enter Description"]) ?>

                <?= $form->field($model, 'course_status')->dropDownList([0 => 'Non-active', 1 => 'Active']) ?>

                <?= $form->field($model, 'course_content')->textarea(['placeholder' => "Enter Content", 'rows' => 6]) ?>

            </div>
            <div class="col-lg-6 col-md-6">
                <?= $form->field($model, 'course_type')->textInput(['placeholder' => "Enter Type"]) ?>

                <?= $form->field($model, 'course_price')->textInput(['placeholder' => "Enter Price"]) ?>

                <?= $form->field($model, 'course_star')->dropDownList([
                    0 => '0',
                    1 => '1',
                    2 => '2',
                    3 => '3',
                    4 => '4',
                    5 => '5'
                ]) ?>

                <div class="form-group highlight-addon field-courses-course_trainer required">
                    <label class="control-label has-star col-md-2" for="courses-course_trainer">Trainer</label>
                    <div class="col-md-10">
                        <select class="form-control" id="course-trainer" name="Courses[course_trainer]">
                            <?php foreach ($users as $k => $v) : ?>
                                <option value="<?= $k ?>"><?= $v ?></option>
                            <?php endforeach; ?>
                        </select>
                        <div class="help-block"></div>
                    </div>
                </div>
            </div>
        </div>

        <?= Html::submitButton(
            $model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'),
            ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']
        );
        ActiveForm::end(); ?>

    </div>

</div>

views/courses/_form_template.php
<?php

use yii\helpers\Html;
use kartik\widgets\ActiveForm;
use kartik\builder\Form;
use kartik\datecontrol\DateControl;
use dosamigos\ckeditor\CKEditor;
use kartik\widgets\StarRating;

/**
 * @var yii\web\View $this
 * @var app\models\Courses $model
 * @var yii\widgets\ActiveForm $form
 */
?>

<div class="card card-primary">
    <div class="card-header">
        <h3 class="card-title">Courses</h3>
    </div>

    <div class="card-body">


        <?php $form = ActiveForm::begin(['type' => ActiveForm::TYPE_HORIZONTAL, 'options' => ['enctype' => 'multipart/form-data']]); ?>

        <div class="row">
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">

                <div class="form-group highlight-addon field-courses-course_title required">
                    <label class="control-label has-star col-md-2" for="courses-course_title">Template</label>
                    <div class="col-md-10">
                        <select class="form-control" id="template" name="template">
                            <?php foreach ($courses as $k => $v) : ?>
                                <option value="<?= $k ?>"><?= $v ?></option>
                            <?php endforeach; ?>
                        </select>
                        <div class="help-block"></div>
                    </div>
                </div>

            </div>
            <div class="col-lg-6 col-md-6">

                <div class="form-group highlight-addon field-courses-course_trainer required">
                    <label class="control-label has-star col-md-2" for="courses-course_trainer">Trainer</label>
                    <div class="col-md-10">
                        <select class="form-control" id="trainer" name="trainer">
                            <?php foreach ($users as $k => $v) : ?>
                                <option value="<?= $k ?>"><?= $v ?></option>
                            <?php endforeach; ?>
                        </select>
                        <div class="help-block"></div>
                    </div>
                </div>

            </div>
        </div>

        <?= Html::submitButton(
            $model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'),
            ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']
        );
        ActiveForm::end(); ?>

    </div>

</div>

views/courses/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/**
 * @var yii\web\View $this
 * @var app\models\CoursesSearch $model
 * @var yii\widgets\ActiveForm $form
 */
?>

<div class="courses-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'course_id') ?>

    <?= $form->field($model, 'course_title') ?>

    <?= $form->field($model, 'course_desc') ?>

    <?= $form->field($model, 'course_content') ?>

    <?= $form->field($model, 'course_type') ?>

    <?php // echo $form->field($model, 'course_is_online') ?>

    <?php // echo $form->field($model, 'course_price') ?>

    <?php // echo $form->field($model, 'course_star') ?>

    <?php // echo $form->field($model, 'course_created_by') ?>

    <?php // echo $form->field($model, 'course_created_at') ?>

    <?php // echo $form->field($model, 'course_modified_by') ?>

    <?php // echo $form->field($model, 'course_modified_at') ?>

    <?php // echo $form->field($model, 'course_status') ?>

    <?php // echo $form->field($model, 'course_is_deleted') ?>

    <div class="form-group">
        <?= Html::submitButton('Search', ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton('Reset', ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/courses/create.php
<?php

use yii\helpers\Html;

/**
 * @var yii\web\View $this
 * @var app\models\Courses $model
 */

$this->title = 'Create Courses';
$this->params['breadcrumbs'][] = ['label' => 'Courses', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="courses-create">

    <?= $this->render('_form', [
        'model' => $model,
        'users' => $users,
    ]) ?>

</div>

views/courses/create_from_template.php
<?php

use yii\helpers\Html;

/**
 * @var yii\web\View $this
 * @var app\models\Courses $model
 */

$this->title = 'Create Courses';
$this->params['breadcrumbs'][] = ['label' => 'Courses', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="courses-create">

    <?= $this->render('_form_template', [
        'model' => $model,
        'users' => $users,
        'courses' => $courses,
    ]) ?>

</div>

views/courses/index.php
<?php

use yii\helpers\Html;
use kartik\grid\GridView;
use yii\helpers\Url;
use yii\widgets\Pjax;

$css = <<<css
.dropdown-menu {
    z-index: 99999;
}
css;

$this->registerCss($css);

/**
 * @var yii\web\View $this
 * @var yii\data\ActiveDataProvider $dataProvider
 * @var app\models\CoursesSearch $searchModel
 */

$this->title = 'Courses';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="courses-index">

    <p>
    <div class="btn-group">
        <button type="button" class="btn btn-default">Create</button>
        <button type="button" class="btn btn-default dropdown-toggle dropdown-icon" data-toggle="dropdown" aria-expanded="true">
            <span class="sr-only">Toggle Dropdown</span>
        </button>
        <div class="dropdown-menu" role="menu" x-placement="top-start" style="position: absolute; will-change: transform; top: 0px; left: 0px; transform: translate3d(68px, -165px, 0px);">
            <a class="dropdown-item" href="<?= Url::to(['create']) ?>">New</a>
            <div class="dropdown-divider"></div>
            <a class="dropdown-item" href="<?= Url::to(['create-from-template']) ?>">From Template</a>
        </div>
    </div>
    </p>

    <?php Pjax::begin();
    echo GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'course_title',
            'course_desc',
            'course_type',

            [
                'class' => 'yii\grid\ActionColumn',
                'buttons' => [
                    'view' => function ($url, $model) {
                        return Html::a(
                            '<span class="fa fa-search"></span>',
                            Yii::$app->urlManager->createUrl(['courses/view', 'id' => $model->course_id, 'view' => 't']),
                            ['title' => Yii::t('yii', 'View'),]
                        );
                    },
                    'update' => function ($url, $model) {
                        return Html::a(
                            '<span class="fa fa-edit"></span>',
                            Yii::$app->urlManager->createUrl(['courses/update', 'id' => $model->course_id, 'edit' => 't']),
                            ['title' => Yii::t('yii', 'Edit'),]
                        );
                    },
                    'delete' => function ($url, $model) {
                        return Html::a(
                            '<span class="fa fa-trash"></span>',
                            Yii::$app->urlManager->createUrl(['courses/delete', 'id' => $model->course_id, 'delete' => 't']),
                            ['title' => Yii::t('yii', 'Delete'),]
                        );
                    }
                ],
            ],
        ],
        'responsive' => true,
        'hover' => true,
        'condensed' => true,
        'floatHeader' => true,
        'pager' => [
            'activePageCssClass' => 'active',
            'pageCssClass' => 'page-item',
            'disabledPageCssClass' => 'page-item disabled',
            'disabledListItemSubTagOptions' =>  [
                'class' => 'page-link',
            ],
            'linkOptions' => [
                'class' => 'page-link',
            ],
            'options' => [
                'class' => 'pagination justify-content-center m-0'
            ],
            'firstPageLabel' => '<span class="fa fa-fast-backward"></span>',
            'lastPageLabel' => '<span class="fa fa-fast-forward"></span>',
            'nextPageLabel' => '<span class="fa fa-step-forward"></span>',
            'prevPageLabel' => '<span class="fa fa-step-backward"></span>',
        ],
    ]);
    Pjax::end(); ?>

</div>

views/courses/update.php
<?php

use yii\helpers\Html;

/**
 * @var yii\web\View $this
 * @var app\models\Courses $model
 */

$this->title = 'Update Courses';
$this->params['breadcrumbs'][] = ['label' => 'Courses', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->course_id, 'url' => ['view', 'id' => $model->course_id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="courses-update">

    <?= $this->render('_form', [
        'model' => $model,
        'users' => $users,
    ]) ?>

</div>

views/courses/view.php
<?php

use app\helpers\ImageHelper;
use yii\base\View;
use yii\helpers\Url;

$this->title = "Course Details"
?>
<div class="container-fluid">
    <div class="row">
        <div class="col-md-3">

            <!-- Profile Image -->
            <div class="card card-primary card-outline">
                <div class="card-body box-profile">
                    <!-- <div class="text-center">
                        <img class="profile-user-img img-fluid img-circle" src="<?= ImageHelper::viewImage("") ?>" alt="User profile picture">
                    </div> -->

                    <h3 class="profile-username text-center"><?= $model->course_title ?></h3>

                    <p class="text-muted text-center"><?= $model->course_type ?></p>

                    <ul class="list-group list-group-unbordered mb-3">
                        <li class="list-group-item">
                            <b>Price</b> <a class="float-right"><?= $model->course_price ?></a>
                        </li>
                        <li class="list-group-item">
                            <b>Rating</b> <a class="float-right"><?= $model->course_star ?></a>
                        </li>
                        <li class="list-group-item">
                            <b>Online</b> <a class="float-right"><?= $model->course_is_online == 1 ? 'Yes' : 'No' ?></a>
                        </li>
                        <li class="list-group-item">
                            <b>Trainer</b> <a class="float-right"><?= $model->courseTrainer ? $model->courseTrainer->user_nama : 'N/A' ?></a>
                        </li>
                    </ul>
                </div>
                <!-- /.card-body -->
            </div>
            <!-- /.card -->

            <!-- About Me Box -->
            <div class="card card-primary">
                <div class="card-header">
                    <h3 class="card-title">Description</h3>
                </div>
                <!-- /.card-header -->
                <div class="card-body">

                    <?= $model->course_desc ?>

                </div>
                <!-- /.card-body -->
            </div>
            <!-- /.card -->
        </div>
        <!-- /.col -->
        <div class="col-md-9">
            <div class="card">
                <div class="card-header p-2">
                    <ul class="nav nav-pills">
                        <li class="nav-item"><a class="nav-link active" href="#activity" data-toggle="tab">Content</a></li>
                        <li class="nav-item"><a class="nav-link" href="#sections" data-toggle="tab">Sections</a></li>
                    </ul>
                </div><!-- /.card-header -->
                <div class="card-body">
                    <div class="tab-content">
                        <div class="active tab-pane" id="activity">
                            <?= $model->course_content ?>
                        </div>
                        <div class="tab-pane" id="sections">
                            <ul>
                                <?php foreach ($sections as $key => $section) : ?>
                                    <li><?= $key ?>
                                        <ul>
                                            <?php foreach ($section as $subsection) : ?>
                                                <li><?= $subsection['subsection_title'] ?></li>
                                            <?php endforeach; ?>
                                        </ul>
                                    </li>
                                <?php endforeach; ?>
                            </ul>
                        </div>
                        <!-- /.tab-pane -->
                    </div>
                    <!-- /.tab-content -->
                </div><!-- /.card-body -->
            </div>
            <!-- /.card -->
        </div>
        <!-- /.col -->
    </div>
    <!-- /.row -->
</div>